/* 
 * nmrc-prng.c - Simple Nomad <thegnome@nmrc.org>
 *
 * NMRC PRNG - based off of mi2g's press releases, in an attempt
 * to duplicate their numbers used.
 * $Id: $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "config.h"
#include "rand_gen.h"

// nothing sez 'leet like getting in on the worm insult bandwagon, this should
// show up nicely with 'strings'
const char *shoutz="Netsky AntiVirus - Gif up, bagle & mydoom, dude! You are fucking your mother! I want to meet you in the U,S.A, Road-App time enc:[fg.od.jgij], and you will know what pain is";

void hello(void)
{
	printf("NMRC PRNG for Governments and Security Companies v%s\n",VERSION);
	printf("Based off of mi2g press releases and assorted U.S. Government budgets\n");
	printf("Copyright (c) 2004 NMRC\n\n");
}

// if you are elite enough to use the elite option, you might notice a slight
// performance improvement during program execution
void elite_test(int elite)
{
	if(!elite) sleep(2);
}

void usage(char *prog)
{
	printf("USAGE: %s <options>\n",prog);
	printf("option     purpose\n");
	printf("---------- ------------------------------------------------------------------\n");
	printf(" -h        This help screen\n");
	printf(" -x        Xforce mode, requires cape (for +6 Charisma during press releases)\n");
	printf(" -e        Elite mode, increases eliteness\n");
	printf(" -r        Russ Cooper mode\n");
	printf(" -q        Quiet mode\n");
	printf(" -v        Verbose output\n");
	printf(" -s        Generate number of times you shit yourself reading own reports\n");
	printf(" -n <name> Use <name> in output (default is \"mi2g\")\n");
}

int main(int argc, char** argv)
{
	char *prog;
	char *name;
	int c,ret,hg,years,verbose=0,quiet=0,xforce=0,elite=0,russ=0;
	int orgs=0,hackers=0,attacks=0,shit=0,nameflag=0;
	int attacks2=0,dollars=0,shit_rand=0;
	int russmode=0;

	prog = argv[0];
	name = "mi2g";

	while ((c = getopt(argc, argv, "n:srexqvh")) != EOF) 
	{
		switch(c)
		{
			case 'n':
				name = strdup(optarg);
				nameflag = 1;
				break;
			case 's':
				shit = 1;
				break;
			case 'r':
				russ++;
				break;
			case 'e':
				elite++;
				break;
			case 'x':
				xforce++;
				break;
			case 'q':
				quiet++;
				break;
			case 'v':
				verbose++;
				break;
			case 'h':
				hello();
				usage(prog);
				exit(0);
			default:
				hello();
				usage(prog);
				exit(-1);
		}
	}
	/* post arg processing */
	if((verbose) && (quiet))
	{
		printf("*** You selected both the verbose and quiet option,\n");
		printf("*** report to Marketing for your new promotion.\n\n");
		usage(prog);
		exit(-1);
	}
	if((xforce) && (elite))
	{
		printf("*** Using the Xforce and Elite options at the same time is, well, impossible.\n\n");
		usage(prog);
		exit(-1);
	}
	if(russ > 1)
	{
		printf("*** You've invoked Russ Cooper mode twice. This computerdoesn't have enough\n");
		printf("*** disk space, RAM, or CPU to support more than one Russ Cooper ego.\n\n");
		usage(prog);
		exit(-1);
	}

	if(!quiet) hello();
	if(russ)
	{
		printf("\nWARNING: Russ Cooper mode, ");
		if(quiet)
		{
			quiet = 0;
			printf("quiet mode removed, ");
		}
		if(elite)
		{
			elite = 0;
			printf("elite mode removed, ");
		}
		printf("+12 Ego, -6 Charisma\n\n");
		scanf("%d",russmode); // <-- this should really put you in 
                                      //     russ mode, DO NOT CHANGE!!!
	}

	if(verbose) printf("[+] Seeding random number\n");
	ret = seed_rand_num();
	if(ret == -1)
	{
		printf("[-] Bummer, unknown bug while seeding random number\n");
		exit(-1);
	}
	// gen # of hackers
	if(verbose) printf("[+] Generating random number of hackers\n");
	hackers = get_rand_num(R_BYTE) + elite;
	if(hackers < 2) hackers = 2;
	elite_test(elite);
	// gen # of hacker organizations
	if(verbose) printf("[+] Generating random number of hacker organizations\n");
	orgs = get_rand_num(R_BYTE) + elite;
	if(orgs < 2) orgs = 2;
	elite_test(elite);
	// gen # of attack attempts
	if(verbose) printf("[+] Generating random number of attack attempts\n");
	attacks = get_rand_num(R_BYTE) + elite;
	if(attacks < 2) attacks = 2;
	elite_test(elite);
	// gen # of successful attacks
	if(verbose) printf("[+] Generating random number of successful attacks\n");
	attacks2 = get_rand_num(R_BYTE) + elite;
	if(attacks2 < 2) attacks2 = 2;
	elite_test(elite);
	// gen damage
	if(verbose) printf("[+] Generating random damage amount\n");
	dollars = get_rand_num(R_BYTE) + elite;
	if(dollars < 2) dollars = 2;
	elite_test(elite);

	if(shit)
	{
		if(verbose) printf("[+] Generating random number of self-shitting messes created\n");
		shit_rand = get_rand_num(R_BYTE);
		if(shit_rand < 2) shit_rand = 2;
		elite_test(elite);
	}
	if(verbose) printf("[+] Generating remaining random data\n");
	years = 2 * (get_rand_num(R_BIT) + get_rand_num(R_BIT) + get_rand_num(R_BIT) + 1);
        elite_test(elite);

	if(verbose) printf("[+] Generating report....\n");
	elite_test(elite);
	printf("\n----------------Below this line is report----------------\n\n");
	printf("%s Cyberspace Intelligence Report\n\n",name);
	printf("This report was prepared by the research team of %s.\n",name);
	printf("It based on research compiled over the last %d years, with the report taking\n",years);
	printf("approximately %d weeks to compile.\n\n",(int)get_rand_num(R_BYTE));

	printf("%s monitors %d000+ individual hackers from its huge hacker database.\n",name,hackers);
	printf("Additionally, %s monitors %d00+ hacker groups listed as active \nin the %s database.\n",name,orgs,name);
	printf("The hackers and hacker organizations are located in countries around\nthe world.\n");
	

	printf("In the past month, %s has seen over %d0000 overt and covert\n",name,attacks);
	printf("attacks attempted, with over %d000 successful. The %d000+ successful\n",attacks2,attacks2);
	printf("attacks resulted in approximately $%d000000 USD of damage.\n",dollars); 
	printf("Data is collected via our vast intelligence gathering network, which has nodes\nin over %d countries -- all who support %s efforts.\n",(int)get_rand_num(R_BYTE),name);
	if(shit)
	{
		printf("While preparing this report, %s analysts actually shit themselves\n",name);
		printf("%d times, due to the sheer intensity of the cyberthreats.\n",shit_rand);
	}
	printf("\n----------------Above this line is report----------------\n");
	exit(0);
}
